package musicplayerviewwrapper;

import main.java.co.mobiwise.library.MusicPlayerView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("MusicPlayerView")
public class musicPlayerViewWrapper extends ViewWrapper<MusicPlayerView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private MusicPlayerView cv;
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new MusicPlayerView(ba.context,null);
                this.setObject(cv);
//                setEventName(this.eventName);
                addListener();
 	}


//        @Hide
//        public void setEventName(String en){
//            cv.setEventName(en);
//            cv.invalidate(); 
//       }


    @Hide
    public void addListener(){
        cv.setCallback(new MusicPlayerView.Callback() {
            @Override
            public void paused() {

              if (ba.subExists(eventName + "_paused")) {
                ba.raiseEvent2(ba, false, eventName + "_paused", true, new Object[0]);
              }
            }

            @Override
            public void started() {

              if (ba.subExists(eventName + "_started")) {
                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
              }
            }


        });
    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}


    /**
     * If you do not want to automatic progress, you can disable it
     * and implement your own handler by using setProgress method repeatedly.
     * @param isAutoProgress
     */
    public void setAutoProgress(boolean isAutoProgress){
        cv.setAutoProgress(isAutoProgress);
        cv.invalidate();
    }

    /**
     * Sets time text color
     * @param color
     */
    public void setTimeColor(int color){
        cv.setTimeColor(color);
        cv.invalidate();
    }

    public void setProgressVisibility(boolean mProgressVisibility){
        cv.setProgressVisibility(mProgressVisibility);
        cv.invalidate();
    }


    public void setButtonColor(int color) {
        cv.setButtonColor(color);
        cv.invalidate();
    }

    /**
     * sets progress empty color
     * @param color
     */
    public void setProgressEmptyColor(int color){
       cv.setProgressEmptyColor(color);
       cv.invalidate();
    }

    /**
     * sets progress loaded color
     * @param color
     */
    public void setProgressLoadedColor(int color){
       cv.setProgressLoadedColor(color);
       cv.invalidate();
    }

    /**
     * Sets total seconds of music
     * @param maxProgress
     */
    public void setMax(int maxProgress){
        cv.setMax(maxProgress);
        cv.invalidate();
    }

    /**
     * Sets current seconds of music
     * @param currentProgress
     */
    public void setProgress(int currentProgress){
          cv.setProgress(currentProgress);
          cv.invalidate();
    }

    /**
     * Get current progress seconds
     * @return
     */
    public int getProgress(){
        return cv.getProgress();
    }







    public boolean isRotating() {
        return cv.isRotating();
    }

    /**
     * Start turning image
     */
    public void start() {
       cv.start();
       cv.invalidate();
    }

    /**
     * Stop turning image
     */
    public void stop() {
        cv.stop();
        cv.invalidate();
    }

    /**
     * Set velocity.When updateCoverRotate() method called,
     * increase degree by velocity value.
     *
     * @param velocity
     */
    public void setVelocity(int velocity) {
        cv.setVelocity(velocity);
        cv.invalidate();
    }

    /**
     * set cover image resource
     *
     * @param coverDrawable
     */
//    public void setCoverDrawable(int coverDrawable) {
//        Drawable drawable = getContext().getDrawable(coverDrawable);
//        mBitmapCover = drawableToBitmap(drawable);
//        createShader();
//        postInvalidate();
//    }

    /**
     * gets image URL and load it to cover image.It uses Picasso Library.
     *
     * @param imageUrl
     */
    public void setCoverURL(String imageUrl) {
        cv.setCoverURL(imageUrl);
        cv.invalidate();
    }

    public void setCoverPicture (Drawable drawcover){
        cv.setCoverPicture(drawcover);
        cv.invalidate();
    }

    public void setCoverBitmap (Bitmap bitmapcover){
        cv.setCoverBitmap(bitmapcover);
        cv.invalidate();
    }



}
